# aidge_shared_files

This repository holds files common to the repositories of the Aidge group.

Most files are in the .gitlab folder which contains :
1. Issue templates
2. Pipeline templates
3. .gitlab-ci.yml files (the most important)

## gitlab-ci.yml files
The CI files contain all the ci jobs and are referenced in most repositories in the .gitlab-ci.yml files.

Here is an exemple of .gitlab-ci.yml file you can place in any repository where you want to use the ci developped here :
```yml
###############################################################################
#                 Aidge Continuous Integration and Deployment                 #
#                                                                             #
###############################################################################

stages:
  - static_analysis
  - build
  - test
  - coverage
  - release
  - deploy

include:
  - project: 'eclipse/aidge/gitlab_shared_files' # do not modify
    ref: 'main' # branch to reference in the repo mentionned above, do not change unless you are developping on this repository and want to make tests
    file: 
      # choose which jobs to run on your ci by including the corresponding files
      - '.gitlab/ci/ubuntu_cpp.gitlab-ci.yml'

      - '.gitlab/ci/ubuntu_python.gitlab-ci.yml'
      - '.gitlab/ci/release/cibuildwheel_ubuntu.gitlab-ci.yml'   
      ###########################
      # This repository builds platform dependent packages (with .so in it) hence, simple pip release is not enough, it needs cibuildwheel.
      # But just so you know, currently pip packaging uses ubuntu_python pipeline to run
      # - '.gitlab/ci/release/pip.gitlab-ci.yml'  

      ###########################
      # This repository doesn't builds on windows, hence these files are not imported.
      # - '.gitlab/ci/windows_cpp.gitlab-ci.yml'

      # - '.gitlab/ci/windows_python.gitlab-ci.yml'   
      # - '.gitlab/ci/release/cibuildwheel_windows.gitlab-ci.yml'   
```
